## ismrmrd 1.2.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(ISMRMRD)

# set project specific cmake module path
set (ISMRMRD_CMAKE_DIR ${PROJECT_SOURCE_DIR}/cmake CACHE PATH
  "Location of CMake scripts")

# command line options
option(USE_SYSTEM_PUGIXML "Use pugixml installed on the system" OFF)

# and include it to the search list
list(APPEND CMAKE_MODULE_PATH ${ISMRMRD_CMAKE_DIR})

# whether to install dependencies
if (WIN32)
    OPTION(ISMRMRD_INSTALL_DEPENDENCIES "Install ismrmrd dependencies in windows" Off)
endif (WIN32)

# set the build type to Release if not specified
IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE Release CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

# compiler flags
if (WIN32)
    add_definitions(-DWIN32 -D_WIN32 -D_WINDOWS)
    add_definitions(-DUNICODE -D_UNICODE)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /EHsc")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W3")
    set(CMAKE_EXE_LINKER_FLAGS_DEBUG "/debug /INCREMENTAL:NO")
    set(CMAKE_SHARED_LINKER_FLAGS_DEBUG "/debug /INCREMENTAL:NO")
    set(CMAKE_STATIC_LINKER_FLAGS_DEBUG "/debug /INCREMENTAL:NO")
    set(CMAKE_MODULE_LINKER_FLAGS_DEBUG "/debug /INCREMENTAL:NO")
    add_definitions(-D__func__=__FUNCTION__)
else (WIN32)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99 -Wall")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
endif (WIN32)

#  ---   VERSIONING  (begin) ----
#The ISMRMRD convention is to use version numbers with the format:
#   XX.YY.ZZ (major, minor, patch)
#
#The major number increments when the binary compatibility of
#the fixed memory layout struts (e.g. AcquisitionHeader) is broken.
#The minor number changes when there are changes to the XML schema for 
#the flexible header. The micro number changes when there are small changes
#in the utility libraries, that don't affect the data format itself.
set(ISMRMRD_VERSION_MAJOR 1)
set(ISMRMRD_VERSION_MINOR 2)
set(ISMRMRD_VERSION_PATCH 3) 

set(ISMRMRD_XML_SCHEMA_SHA1 "99a63f4e8cf08ffc268f5ee8b8c8b2a1edf69412")

#Remove line breaks and white space that does not change the meaning of the schema
file(STRINGS ${CMAKE_SOURCE_DIR}/schema/ismrmrd.xsd SCHEMA_STRINGS) #Read all strings from file 
string(REPLACE ";" "" SCHEMA_NO_BREAKS  ${SCHEMA_STRINGS}) #Concatenate the list of strings
string(REGEX REPLACE ">[ \t]+<" "><" SCHEMA_NO_SPACE ${SCHEMA_NO_BREAKS}) #Remove spaces and tabs
string(STRIP ${SCHEMA_NO_SPACE} SCHEMA_NO_SPACE) #Strip any leading/trailing whitespace
file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/ismrmrd_no_white_space.xsd ${SCHEMA_NO_SPACE}) #Write to file

#Now hash the cleaned up file
file(SHA1 ${CMAKE_CURRENT_BINARY_DIR}/ismrmrd_no_white_space.xsd ISMRMRD_CURRENT_XML_SCHEMA_SHA1)

#Compare to last known hash
if (NOT (${ISMRMRD_XML_SCHEMA_SHA1} STREQUAL ${ISMRMRD_CURRENT_XML_SCHEMA_SHA1}))
  message("")
  message("-----------------------------------------------")
  message("            !!VERSION ERROR!!                  ")
  message("                                               ")
  message(" Expected SHA1 hash:                           ")
  message("    ${ISMRMRD_XML_SCHEMA_SHA1}")
  message(" Actual SHA1 hash:                             ")
  message("    ${ISMRMRD_CURRENT_XML_SCHEMA_SHA1}")
  message("                                               ")
  message(" The XML Schema (ismrmrmd.xsd) has changed and ")
  message(" the MINOR version number should be increased  ")
  message(" and the SHA1 has should be updated in the     ")
  message(" CMakelists.txt file.                          ")
  message("                                               ")
  message(" If you don't know what this message means, you")
  message(" probably shouldn't be changing anything       ")
  message("-----------------------------------------------")
  message("")
  message(FATAL_ERROR "     FATAL XML VERSION ERROR")
endif()

set(ISMRMRD_VERSION_STRING ${ISMRMRD_VERSION_MAJOR}.${ISMRMRD_VERSION_MINOR}.${ISMRMRD_VERSION_PATCH})
set(ISMRMRD_SOVERSION ${ISMRMRD_VERSION_MAJOR}.${ISMRMRD_VERSION_MINOR})

# Generate the version.h header file
find_package(Git)
if (GIT_FOUND)
    execute_process(COMMAND ${GIT_EXECUTABLE} rev-parse HEAD WORKING_DIRECTORY
            ${CMAKE_SOURCE_DIR} OUTPUT_VARIABLE ISMRMRD_GIT_SHA1 ERROR_VARIABLE ISMRMRD_GIT_STDERR)
    string(STRIP "${ISMRMRD_GIT_SHA1}" ISMRMRD_GIT_SHA1)
    string(LENGTH "${ISMRMRD_GIT_SHA1}" ISMRMRD_GIT_SHA1_LEN)
    if (${ISMRMRD_GIT_SHA1_LEN} LESS 40)
        message(WARNING "Could not determine SHA-1 hash: ${ISMRMRD_GIT_STDERR}")
        set(ISMRMRD_GIT_SHA1 "NA")
    endif (${ISMRMRD_GIT_SHA1_LEN} LESS 40)
else()
  set(ISMRMRD_GIT_SHA1 "NA")
endif()
configure_file(include/version.in ${CMAKE_BINARY_DIR}/include/ismrmrd/version.h)
install(FILES ${CMAKE_BINARY_DIR}/include/ismrmrd/version.h DESTINATION include/ismrmrd)
# note: for the utilities in this project that need ismrmrd/version.h
# remember to add ${CMAKE_BINARY_DIR}/include to the include path

#  ---   VERSIONING  (end) ----
 
#  ---   Main Library  (begin) ----
# required packages for main library
find_package(HDF5 1.8 COMPONENTS C REQUIRED)

# in windows, install the HDF5 dependencies
if (WIN32)
    if (ISMRMRD_INSTALL_DEPENDENCIES)
        if ( HDF5_FOUND )
            if(DEFINED ENV{HDF5_ROOT})
                set(HDF5_BIN_DIR $ENV{HDF5_ROOT}/bin)
            else (DEFINED ENV{HDF5_ROOT})
                set(HDF5_BIN_DIR ${HDF5_C_INCLUDE_DIR}/../bin)
            endif (DEFINED ENV{HDF5_ROOT})
            message("Install hdf5 libraries from ${HDF5_BIN_DIR} ")
            install( DIRECTORY ${HDF5_BIN_DIR} DESTINATION bin/.. FILES_MATCHING PATTERN "*.dll" )
        endif (HDF5_FOUND)
    endif (ISMRMRD_INSTALL_DEPENDENCIES)
endif (WIN32)

# include directories for main library
set(ISMRMRD_TARGET_INCLUDE_DIRS
  include
  ${CMAKE_BINARY_DIR}/include
  ${HDF5_C_INCLUDE_DIR}
)

set(ISMRMRD_TARGET_SOURCES
  libsrc/ismrmrd.c
  libsrc/ismrmrd.cpp
  libsrc/dataset.c
  libsrc/dataset.cpp
  libsrc/xml.cpp
  libsrc/meta.cpp
)

set(ISMRMRD_TARGET_LINK_LIBS ${HDF5_LIBRARIES})

# optional handling of system-installed pugixml
if(USE_SYSTEM_PUGIXML)
  find_package(PugiXML)
  if(PugiXML_FOUND)
    message("Found system pugixml: ${PugiXML_INCLUDE_DIR} ${PugiXML_LIBRARY}")
    list(APPEND ISMRMRD_TARGET_INCLUDE_DIRS ${PugiXML_INCLUDE_DIR})
    list(APPEND ISMRMRD_TARGET_LINK_LIBS ${PugiXML_LIBRARY})
  else(PugiXML_FOUND)
    message(FATAL_ERROR "Pugixml library not found on the system, try without "
    "setting USE_SYSTEM_PUGIXML to use the version provided in the source "
    "tree.")
  endif(PugiXML_FOUND)
  list(APPEND ISMRMRD_TARGET_INCLUDE_DIRS ${PugiXML_INCLUDE_DIR})
  list(APPEND ISMRMRD_TARGET_LINK_LIBS ${PugiXML_LIBRARY})
else(USE_SYSTEM_PUGIXML)
  list(APPEND ISMRMRD_TARGET_SOURCES libsrc/pugixml.cpp)
endif(USE_SYSTEM_PUGIXML)

# main library
include_directories(${ISMRMRD_TARGET_INCLUDE_DIRS})
add_library(ismrmrd SHARED ${ISMRMRD_TARGET_SOURCES})
set_target_properties(ismrmrd PROPERTIES
  VERSION ${ISMRMRD_VERSION_STRING}
  SOVERSION ${ISMRMRD_SOVERSION}
)
target_link_libraries(ismrmrd ${ISMRMRD_TARGET_LINK_LIBS})

# install the main library
install(TARGETS ismrmrd DESTINATION lib)

# install the headers
install(DIRECTORY include/ismrmrd  DESTINATION include)

# install the schema file
install(FILES schema/ismrmrd.xsd
  DESTINATION share/ismrmrd/schema)

# install the cmake modules
install(FILES
  cmake/FindIsmrmrd.cmake
  cmake/FindFFTW3.cmake
  cmake/FindNumPy.cmake
DESTINATION
  share/ismrmrd/cmake
)

#  ---   Main Library  (end) ----

# turn on testing
enable_testing()

# process subdirectories
add_subdirectory(doc)
add_subdirectory(examples/c)
add_subdirectory(utilities)

# install the matlab api
install(DIRECTORY matlab DESTINATION share/ismrmrd)

# TODO build and install the python bindings

# Create package
string(TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)
include(${ISMRMRD_CMAKE_DIR}/ismrmrd_cpack.cmake)
if(CPACK_GENERATOR)
  message(STATUS "Found CPack generators: ${CPACK_GENERATOR}")
  configure_file("${ISMRMRD_CMAKE_DIR}/cpack_options.cmake.in"
    ${ISMRMRD_CPACK_CFG_FILE} @ONLY)
  set(CPACK_PROJECT_CONFIG_FILE ${ISMRMRD_CPACK_CFG_FILE})
  include (CPack)
endif()

=== doc/CMakeLists.txt ===
find_package(Doxygen)
if(DOXYGEN_FOUND)
    set(API_DOC_DIR ${CMAKE_CURRENT_BINARY_DIR}/html/api)
    set(DOXYFILE ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)

    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${DOXYFILE} @ONLY)

    add_custom_target(apidoc
        COMMAND ${CMAKE_COMMAND} -E make_directory ${API_DOC_DIR}
        COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYFILE}
        COMMENT "Generating API documentation using Doxygen" VERBATIM)
else(DOXYGEN_FOUND)
    MESSAGE(STATUS "Doxygen not found. Not able to build API documentation")
endif(DOXYGEN_FOUND)

find_program(SPHINXBUILD sphinx-build)
if(SPHINXBUILD)
    if(WIN32)
        set(SPHINX_MAKEBAT ${CMAKE_CURRENT_BINARY_DIR}/make.sphinx.bat)
        configure_file(make.sphinx.bat.in ${SPHINX_MAKEBAT} @ONLY)
        add_custom_target(htmldoc
            COMMAND ${SPHINX_MAKEBAT} html
            COMMAND ${CMAKE_COMMAND} -E touch ${CMAKE_CURRENT_BINARY_DIR}/html/.nojekyll
            COMMENT "Generating HTML docs using Sphinx" VERBATIM)
    else(WIN32)
        set(SPHINX_MAKEFILE ${CMAKE_CURRENT_BINARY_DIR}/Makefile.sphinx)
        configure_file(Makefile.sphinx.in ${SPHINX_MAKEFILE} @ONLY)
        add_custom_target(htmldoc
            COMMAND make -f ${SPHINX_MAKEFILE} html
            COMMAND ${CMAKE_COMMAND} -E touch ${CMAKE_CURRENT_BINARY_DIR}/html/.nojekyll
            COMMENT "Generating HTML docs using Sphinx" VERBATIM)
    endif(WIN32)
else(SPHINXBUILD)
    MESSAGE(STATUS "sphinx-build not found. Not able to build HTML project documentation")
endif(SPHINXBUILD)

add_custom_target(doc)
add_dependencies(doc apidoc htmldoc)

=== utilities/CMakeLists.txt ===
# Build the info application
message("Building info application")
include_directories(${CMAKE_BINARY_DIR}/include
                    ${CMAKE_SOURCE_DIR}/include
		    ${CMAKE_SOURCE_DIR}/libsrc)

add_executable(ismrmrd_info ismrmrd_info.cpp)
target_link_libraries(ismrmrd_info ismrmrd)
install(TARGETS ismrmrd_info DESTINATION bin)

add_executable(ismrmrd_read_timing_test read_timing_test.cpp)
target_link_libraries(ismrmrd_read_timing_test ismrmrd)
install(TARGETS ismrmrd_read_timing_test DESTINATION bin)

if (NOT WIN32)
  add_executable(ismrmrd_test_xml 
    ismrmrd_test_xml.cpp 
    ${CMAKE_SOURCE_DIR}/libsrc/pugixml.cpp )
  target_link_libraries(ismrmrd_test_xml ismrmrd)
  install(TARGETS ismrmrd_test_xml DESTINATION bin)
endif(NOT WIN32)

find_package(Boost 1.43 COMPONENTS program_options)
find_package(FFTW3 COMPONENTS single)

if(FFTW3_FOUND AND Boost_FOUND)
    message("FFTW3 and Boost Found, building utilities")
    
    if(WIN32)
        link_directories(${Boost_LIBRARY_DIRS})
    endif(WIN32)

    include_directories(
        ${CMAKE_SOURCE_DIR/include}
        ${Boost_INCLUDE_DIR}
        ${FFTW3_INCLUDE_DIR})

    # Shepp-Logan phantom
    add_executable(ismrmrd_generate_cartesian_shepp_logan
        generate_cartesian_shepp_logan.cpp
        ismrmrd_phantom.cpp)
    if(WIN32)
        target_link_libraries( ismrmrd_generate_cartesian_shepp_logan
            ismrmrd
            ${FFTW3_LIBRARIES})
    else(WIN32)
        target_link_libraries( ismrmrd_generate_cartesian_shepp_logan
            ismrmrd
            ${Boost_PROGRAM_OPTIONS_LIBRARY}
            ${FFTW3_LIBRARIES})
    endif(WIN32)
    install(TARGETS ismrmrd_generate_cartesian_shepp_logan
			DESTINATION bin)

    # Shepp-Logan phantom
    add_executable(ismrmrd_recon_cartesian_2d
	recon_cartesian_2d.cpp)
    if(WIN32)
        target_link_libraries( ismrmrd_recon_cartesian_2d
            ismrmrd
            ${FFTW3_LIBRARIES})
    else(WIN32)
        target_link_libraries( ismrmrd_recon_cartesian_2d
            ismrmrd
            ${Boost_PROGRAM_OPTIONS_LIBRARY}
            ${FFTW3_LIBRARIES})
    endif(WIN32)
    install(TARGETS ismrmrd_recon_cartesian_2d
			DESTINATION bin)

else(FFTW3_FOUND AND Boost_FOUND)
	message("FFTW3 or Boost NOT Found, cannot build utilities")
endif(FFTW3_FOUND AND Boost_FOUND)

=== examples/c/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/include)

add_executable(ismrmrd_c_demo main.c)
target_link_libraries(ismrmrd_c_demo ismrmrd)
install(TARGETS ismrmrd_c_demo DESTINATION bin)

=== debian/changelog ===
ismrmrd (1.2.3-2build2) wily; urgency=medium

  * No-change rebuild for hdf5 soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 06 Oct 2015 12:21:44 +0000

ismrmrd (1.2.3-2build1) wily; urgency=medium

  * No-change rebuild against libpugixml1v5

 -- Martin Pitt <martin.pitt@ubuntu.com>  Wed, 12 Aug 2015 12:18:59 +0200

ismrmrd (1.2.3-2) unstable; urgency=medium

  * Make package build reproducible.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 02 Jul 2015 18:33:32 +0100

ismrmrd (1.2.3-1) unstable; urgency=medium

  * New upstream release. 

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 18 Jun 2015 17:19:20 +0100

ismrmrd (1.2.1-1) unstable; urgency=low

  * Initial release (Closes: #732360)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Fri, 20 Feb 2015 16:28:54 +0000

=== debian/control ===
Source: ismrmrd
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper (>= 9),
               doxygen,
               libboost-program-options-dev,
               libfftw3-dev,
               libhdf5-serial-dev,
               libpugixml-dev
Standards-Version: 3.9.6
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/ismrmrd.git
Vcs-Git: git://anonscm.debian.org/debian-med/ismrmrd.git 
Homepage: http://ismrmrd.github.io/

Package: libismrmrd1.2
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: ISMRM Raw Data format (ISMRMRD) - shared library
 The ISMRMRD format combines a mix of flexible data structures (XML header) 
 and fixed structures (equivalent to C-structs) to represent MRI data.
 .
 In addition, the ISMRMRD format also specifies an image header for storing 
 reconstructed images and the accompanying C++ library provides a convenient 
 way of writing such images into HDF5 files along with generic arrays for 
 storing less well defined data structures, e.g. coil sensitivity maps or 
 other calibration data.
 .
 This package provides the shared library.

Package: libismrmrd-dev
Architecture: any
Section: libdevel
Depends: ismrmrd-schema,
         libismrmrd1.2 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: libismrmrd-doc
Description: ISMRM Raw Data format (ISMRMRD) - development files
 The ISMRMRD format combines a mix of flexible data structures (XML header) 
 and fixed structures (equivalent to C-structs) to represent MRI data.
 .
 In addition, the ISMRMRD format also specifies an image header for storing 
 reconstructed images and the accompanying C++ library provides a convenient 
 way of writing such images into HDF5 files along with generic arrays for 
 storing less well defined data structures, e.g. coil sensitivity maps or 
 other calibration data.
 .
 This package provides the development files.

Package: libismrmrd-doc
Architecture: all
Section: doc
Depends: libjs-jquery,
         ${misc:Depends}
Description: ISMRM Raw Data format (ISMRMRD) - documentation
 The ISMRMRD format combines a mix of flexible data structures (XML header) 
 and fixed structures (equivalent to C-structs) to represent MRI data.
 .
 In addition, the ISMRMRD format also specifies an image header for storing 
 reconstructed images and the accompanying C++ library provides a convenient 
 way of writing such images into HDF5 files along with generic arrays for 
 storing less well defined data structures, e.g. coil sensitivity maps or 
 other calibration data.
 .
 This package provides the documentation.

Package: ismrmrd-tools
Architecture: any
Depends: ismrmrd-schema,
         libismrmrd1.2 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: ISMRM Raw Data format (ISMRMRD) - binaries
 The ISMRMRD format combines a mix of flexible data structures (XML header) 
 and fixed structures (equivalent to C-structs) to represent MRI data.
 .
 In addition, the ISMRMRD format also specifies an image header for storing 
 reconstructed images and the accompanying C++ library provides a convenient 
 way of writing such images into HDF5 files along with generic arrays for 
 storing less well defined data structures, e.g. coil sensitivity maps or 
 other calibration data.
 .
 This package provides the binaries.

Package: ismrmrd-schema
Architecture: all
Depends: ${misc:Depends}
Description: ISMRM Raw Data format (ISMRMRD) - XML schema
 The ISMRMRD format combines a mix of flexible data structures (XML header) 
 and fixed structures (equivalent to C-structs) to represent MRI data.
 .
 In addition, the ISMRMRD format also specifies an image header for storing 
 reconstructed images and the accompanying C++ library provides a convenient 
 way of writing such images into HDF5 files along with generic arrays for 
 storing less well defined data structures, e.g. coil sensitivity maps or 
 other calibration data.
 .
 This package provides the XML schema.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

BUILDDIR = $(CURDIR)/debian/build

%:
	dh $@ --buildsystem=cmake --builddirectory=$(BUILDDIR) --parallel

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX=/usr \
		-DUSE_SYSTEM_PUGIXML=ON

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(BUILDDIR)

override_dh_auto_build:
	dh_auto_build
	# Make doc
	cd $(BUILDDIR) && $(MAKE) apidoc

## ismrmrd 1.3.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -50,10 +50,10 @@
 #the flexible header. The micro number changes when there are small changes
 #in the utility libraries, that don't affect the data format itself.
 set(ISMRMRD_VERSION_MAJOR 1)
-set(ISMRMRD_VERSION_MINOR 2)
-set(ISMRMRD_VERSION_PATCH 3) 
-
-set(ISMRMRD_XML_SCHEMA_SHA1 "99a63f4e8cf08ffc268f5ee8b8c8b2a1edf69412")
+set(ISMRMRD_VERSION_MINOR 3)
+set(ISMRMRD_VERSION_PATCH 2)
+
+set(ISMRMRD_XML_SCHEMA_SHA1 "9b899c6ad806bc2388c70461d6e5affe5cc6d750")
 
 #Remove line breaks and white space that does not change the meaning of the schema
 file(STRINGS ${CMAKE_SOURCE_DIR}/schema/ismrmrd.xsd SCHEMA_STRINGS) #Read all strings from file 
@@ -91,6 +91,19 @@
 set(ISMRMRD_VERSION_STRING ${ISMRMRD_VERSION_MAJOR}.${ISMRMRD_VERSION_MINOR}.${ISMRMRD_VERSION_PATCH})
 set(ISMRMRD_SOVERSION ${ISMRMRD_VERSION_MAJOR}.${ISMRMRD_VERSION_MINOR})
 
+# Find HDF5 for dataset support
+find_package(HDF5 1.8 COMPONENTS C)
+
+if (HDF5_FOUND)
+    set (ISMRMRD_DATASET_SUPPORT true)
+    set (ISMRMRD_DATASET_SOURCES libsrc/dataset.c libsrc/dataset.cpp)
+    set (ISMRMRD_DATASET_INCLUDE_DIR ${HDF5_C_INCLUDE_DIR})
+    set (ISMRMRD_DATASET_LIBRARIES ${HDF5_LIBRARIES})
+else (HDF5_FOUND)
+    set (ISMRMRD_DATASET_SUPPORT false)
+    message (WARNING "HDF5 not found. Dataset and file support unavailable!")
+endif (HDF5_FOUND)
+
 # Generate the version.h header file
 find_package(Git)
 if (GIT_FOUND)
@@ -111,43 +124,35 @@
 # remember to add ${CMAKE_BINARY_DIR}/include to the include path
 
 #  ---   VERSIONING  (end) ----
- 
+
 #  ---   Main Library  (begin) ----
-# required packages for main library
-find_package(HDF5 1.8 COMPONENTS C REQUIRED)
-
 # in windows, install the HDF5 dependencies
-if (WIN32)
-    if (ISMRMRD_INSTALL_DEPENDENCIES)
-        if ( HDF5_FOUND )
-            if(DEFINED ENV{HDF5_ROOT})
-                set(HDF5_BIN_DIR $ENV{HDF5_ROOT}/bin)
-            else (DEFINED ENV{HDF5_ROOT})
-                set(HDF5_BIN_DIR ${HDF5_C_INCLUDE_DIR}/../bin)
-            endif (DEFINED ENV{HDF5_ROOT})
-            message("Install hdf5 libraries from ${HDF5_BIN_DIR} ")
-            install( DIRECTORY ${HDF5_BIN_DIR} DESTINATION bin/.. FILES_MATCHING PATTERN "*.dll" )
-        endif (HDF5_FOUND)
-    endif (ISMRMRD_INSTALL_DEPENDENCIES)
-endif (WIN32)
+if (HDF5_FOUND AND WIN32 AND ISMRMRD_INSTALL_DEPENDENCIES)
+    if(DEFINED ENV{HDF5_ROOT})
+        set(HDF5_BIN_DIR $ENV{HDF5_ROOT}/bin)
+    else (DEFINED ENV{HDF5_ROOT})
+        set(HDF5_BIN_DIR ${HDF5_C_INCLUDE_DIR}/../bin)
+    endif (DEFINED ENV{HDF5_ROOT})
+    message("Install hdf5 libraries from ${HDF5_BIN_DIR} ")
+    install( DIRECTORY ${HDF5_BIN_DIR} DESTINATION bin/.. FILES_MATCHING PATTERN "*.dll" )
+endif (HDF5_FOUND AND WIN32 AND ISMRMRD_INSTALL_DEPENDENCIES)
 
 # include directories for main library
 set(ISMRMRD_TARGET_INCLUDE_DIRS
   include
   ${CMAKE_BINARY_DIR}/include
-  ${HDF5_C_INCLUDE_DIR}
+  ${ISMRMRD_DATASET_INCLUDE_DIR}
 )
 
 set(ISMRMRD_TARGET_SOURCES
   libsrc/ismrmrd.c
   libsrc/ismrmrd.cpp
-  libsrc/dataset.c
-  libsrc/dataset.cpp
   libsrc/xml.cpp
   libsrc/meta.cpp
+  ${ISMRMRD_DATASET_SOURCES}
 )
 
-set(ISMRMRD_TARGET_LINK_LIBS ${HDF5_LIBRARIES})
+set(ISMRMRD_TARGET_LINK_LIBS ${ISMRMRD_DATASET_LIBRARIES})
 
 # optional handling of system-installed pugixml
 if(USE_SYSTEM_PUGIXML)
@@ -183,40 +188,35 @@
 install(DIRECTORY include/ismrmrd  DESTINATION include)
 
 # install the schema file
-install(FILES schema/ismrmrd.xsd
-  DESTINATION share/ismrmrd/schema)
+install(FILES schema/ismrmrd.xsd DESTINATION share/ismrmrd/schema)
 
 # install the cmake modules
-install(FILES
-  cmake/FindIsmrmrd.cmake
-  cmake/FindFFTW3.cmake
-  cmake/FindNumPy.cmake
-DESTINATION
-  share/ismrmrd/cmake
-)
+install(FILES cmake/FindIsmrmrd.cmake cmake/FindFFTW3.cmake DESTINATION share/ismrmrd/cmake)
 
 #  ---   Main Library  (end) ----
-
-# turn on testing
-enable_testing()
 
 # process subdirectories
 add_subdirectory(doc)
-add_subdirectory(examples/c)
+
 add_subdirectory(utilities)
+if (HDF5_FOUND)
+    add_subdirectory(examples/c)
+endif (HDF5_FOUND)
+
+# TODO: make this work on Windows
+if (NOT WIN32)
+    add_subdirectory(tests)
+endif (NOT WIN32)
 
 # install the matlab api
 install(DIRECTORY matlab DESTINATION share/ismrmrd)
-
-# TODO build and install the python bindings
 
 # Create package
 string(TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)
 include(${ISMRMRD_CMAKE_DIR}/ismrmrd_cpack.cmake)
 if(CPACK_GENERATOR)
   message(STATUS "Found CPack generators: ${CPACK_GENERATOR}")
-  configure_file("${ISMRMRD_CMAKE_DIR}/cpack_options.cmake.in"
-    ${ISMRMRD_CPACK_CFG_FILE} @ONLY)
+  configure_file("${ISMRMRD_CMAKE_DIR}/cpack_options.cmake.in" ${ISMRMRD_CPACK_CFG_FILE} @ONLY)
   set(CPACK_PROJECT_CONFIG_FILE ${ISMRMRD_CPACK_CFG_FILE})
-  include (CPack)
-endif()
+  include(CPack)
+endif(CPACK_GENERATOR)

=== tests/CMakeLists.txt ===
find_package(Boost 1.43 COMPONENTS unit_test_framework)

if (NOT Boost_UNIT_TEST_FRAMEWORK_FOUND)
    message("Boost Unit Test Framework not found. Not compiling tests")
    return()
endif (NOT Boost_UNIT_TEST_FRAMEWORK_FOUND)

include_directories(${CMAKE_SOURCE_DIR}/include ${CMAKE_BINARY_DIR}/include ${Boost_INCLUDE_DIR})

add_executable(test_ismrmrd
    test_main.cpp
    test_acquisitions.cpp
    test_images.cpp
    test_ndarray.cpp
    test_flags.cpp
    test_channels.cpp
    test_quaternions.cpp)

target_link_libraries(test_ismrmrd ismrmrd ${Boost_LIBRARIES})

add_custom_target(check COMMAND ${CMAKE_CURRENT_BINARY_DIR}/test_ismrmrd DEPENDS test_ismrmrd)

=== utilities/CMakeLists.txt ===
# Build the info application
message("Building info application")
include_directories(${CMAKE_BINARY_DIR}/include
                    ${CMAKE_SOURCE_DIR}/include
		    ${CMAKE_SOURCE_DIR}/libsrc)

add_executable(ismrmrd_info ismrmrd_info.cpp)
target_link_libraries(ismrmrd_info ismrmrd)
install(TARGETS ismrmrd_info DESTINATION bin)

if (NOT WIN32)
  add_executable(ismrmrd_test_xml
    ismrmrd_test_xml.cpp
    ${CMAKE_SOURCE_DIR}/libsrc/pugixml.cpp )
  target_link_libraries(ismrmrd_test_xml ismrmrd)
  install(TARGETS ismrmrd_test_xml DESTINATION bin)
endif(NOT WIN32)

if (HDF5_FOUND)
    add_executable(ismrmrd_read_timing_test read_timing_test.cpp)
    target_link_libraries(ismrmrd_read_timing_test ismrmrd)
    install(TARGETS ismrmrd_read_timing_test DESTINATION bin)

    find_package(Boost 1.43 COMPONENTS program_options)
    find_package(FFTW3 COMPONENTS single)

    if(FFTW3_FOUND AND Boost_FOUND)
        message("FFTW3 and Boost Found... building utilities")

        if(WIN32)
            link_directories(${Boost_LIBRARY_DIRS})
        endif(WIN32)

        include_directories(
            ${CMAKE_SOURCE_DIR/include}
            ${Boost_INCLUDE_DIR}
            ${FFTW3_INCLUDE_DIR})

        # Shepp-Logan phantom
        add_executable(ismrmrd_generate_cartesian_shepp_logan
            generate_cartesian_shepp_logan.cpp
            ismrmrd_phantom.cpp)
        if(WIN32)
            target_link_libraries( ismrmrd_generate_cartesian_shepp_logan
                ismrmrd
                ${FFTW3_LIBRARIES})
        else(WIN32)
            target_link_libraries( ismrmrd_generate_cartesian_shepp_logan
                ismrmrd
                ${Boost_PROGRAM_OPTIONS_LIBRARY}
                ${FFTW3_LIBRARIES})
        endif(WIN32)
        install(TARGETS ismrmrd_generate_cartesian_shepp_logan DESTINATION bin)

        # Shepp-Logan phantom
        add_executable(ismrmrd_recon_cartesian_2d
            recon_cartesian_2d.cpp)
        if(WIN32)
            target_link_libraries( ismrmrd_recon_cartesian_2d
                ismrmrd
                ${FFTW3_LIBRARIES})
        else(WIN32)
            target_link_libraries( ismrmrd_recon_cartesian_2d
                ismrmrd
                ${Boost_PROGRAM_OPTIONS_LIBRARY}
                ${FFTW3_LIBRARIES})
        endif(WIN32)
        install(TARGETS ismrmrd_recon_cartesian_2d DESTINATION bin)

    else(FFTW3_FOUND AND Boost_FOUND)
        message("FFTW3 or Boost NOT Found, cannot build utilities")
    endif(FFTW3_FOUND AND Boost_FOUND)
else (HDF5_FOUND)
    message("HDF5 NOT Found, cannot build utilities")
endif (HDF5_FOUND)

=== examples/c/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(ISMRMRD-C-EXAMPLE)

# if building this example as a standalone project
if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
    if(NOT DEFINED ENV{ISMRMRD_HOME})
        message(FATAL_ERROR "ISMRMRD_HOME environment variable must be defined")
    endif(NOT DEFINED ENV{ISMRMRD_HOME})

    list(APPEND CMAKE_MODULE_PATH "$ENV{ISMRMRD_HOME}/share/ismrmrd/cmake")

    find_package(Ismrmrd REQUIRED)

# otherwise, building it as part of ISMRMRD itself
else(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
    set(ISMRMRD_INCLUDE_DIR "${CMAKE_SOURCE_DIR}/include ${CMAKE_BINARY_DIR}/include")
    set(ISMRMRD_LIBRARIES ismrmrd)
endif(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)

include_directories(${ISMRMRD_INCLUDE_DIR})
add_executable(ismrmrd_c_example main.c)
target_link_libraries(ismrmrd_c_example ${ISMRMRD_LIBRARIES})
install(TARGETS ismrmrd_c_example DESTINATION bin)

=== debian/changelog ===
ismrmrd (1.3.2-4) unstable; urgency=medium

  * Fix FTBFS due to buggy HDF5 detection with CMake 3.6.
    Thanks to Lucas Nussbaum for reporting. (Closes: #835679)
  * Update description of binary packages.
  * Add missing Section field for some binary packages.
  * Bump standards version to 3.9.8, no changes required.
  * Use HTTPS for Format field in copyright file.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Fri, 02 Sep 2016 11:27:37 +0100

ismrmrd (1.3.2-3) unstable; urgency=medium

  * d/rules: add missing maintainer CXXFLAGS.
  * Add packaging testsuite.
  * Add patch fixing compilation of examples with the installed find module.
    File: Use-Debian-CMake-find-module-location
  * Bump standards version to 3.9.7, no changes required.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Sat, 05 Mar 2016 17:13:18 +0000

ismrmrd (1.3.2-2) unstable; urgency=medium

  * d/control: use secure VCS-Git URI.
  * Add patch fixing FTBFS in testsuite.
    File: Use-explicit-64-bit-shifts-in-testsuite.patch.
    Thanks to Emilio Pozuelo Monfort (Closes: #802172)
  * Provide examples in doc package.
  * d/control: cme fix, wrap and sort.
  * Fix usage of embedded jquery.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Wed, 03 Feb 2016 19:32:00 +0000

ismrmrd (1.3.2-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patch queue:
    - Drop fixing-check-after-free-in-unit-tests.patch, applied upstream.
    - Drop cmake-install-docs.patch, now using alternative via d/rules.
    - Rename make-build-reproducible.patch to Disable-HTML-timestamps.patch.
    - Add Explicit-64-bit-shifts-for-flags.patch from upstream, should solve
      issues with failing testsuite on some architectures.
  * Simplify packaging of documentation.
  * d/rules: add call to dh_doxygen.
  * Update copyright information:
    - Add upstream contact.
    - Replace MIT by Expat.
    - Wrap and sort.
  * Add gbp.conf file.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Mon, 26 Oct 2015 10:34:42 +0000

ismrmrd (1.3.1-1) unstable; urgency=medium

  * New upstream release.
  * Bump soname of shared library package.
  * Enable test suite, requires build dependency on libboost-test-dev.
  * Use stricter hardening.
  * Make documentation targets architecture-independent:
    - d/control: move documentation dependencies to Build-Depends-Indep,
    - d/p/cmake-install-docs.patch: enable installation of documentation,
    - d/*-doc.install: use installation path set by the above patch,
    - d/rules: split older rules to -arch and -indep.
  * Remove jquery symlink in documentation package.
  * Add d/p/fixing-check-after-free-in-unit-tests.patch, fixes an upstream bug
    in the test suite.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Fri, 18 Sep 2015 09:44:41 +0100

ismrmrd (1.2.3-3) unstable; urgency=medium

  * Team upload.
  * Rebuild with g++ 5
    Closes: #799107

 -- Andreas Tille <tille@debian.org>  Wed, 16 Sep 2015 08:29:53 +0200

=== debian/control ===
--- 
+++ 
@@ -2,24 +2,27 @@
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
 Section: science
+Testsuite: autopkgtest
 Priority: optional
 Build-Depends: cmake,
                debhelper (>= 9),
-               doxygen,
                libboost-program-options-dev,
+               libboost-test-dev,
                libfftw3-dev,
                libhdf5-serial-dev,
                libpugixml-dev
-Standards-Version: 3.9.6
+Build-Depends-Indep: doxygen
+Standards-Version: 3.9.8
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/ismrmrd.git
-Vcs-Git: git://anonscm.debian.org/debian-med/ismrmrd.git 
+Vcs-Git: https://anonscm.debian.org/git/debian-med/ismrmrd.git
 Homepage: http://ismrmrd.github.io/
 
-Package: libismrmrd1.2
+Package: libismrmrd1.3
 Architecture: any
+Section: libs
 Depends: ${misc:Depends},
          ${shlibs:Depends}
-Description: ISMRM Raw Data format (ISMRMRD) - shared library
+Description: ISMRM Raw Data format (ISMRMRD)
  The ISMRMRD format combines a mix of flexible data structures (XML header) 
  and fixed structures (equivalent to C-structs) to represent MRI data.
  .
@@ -34,12 +37,11 @@
 Package: libismrmrd-dev
 Architecture: any
 Section: libdevel
-Depends: ismrmrd-schema,
-         libismrmrd1.2 (= ${binary:Version}),
-         ${misc:Depends},
-         ${shlibs:Depends}
+Depends: ${misc:Depends},
+         ismrmrd-schema,
+         libismrmrd1.3 (= ${binary:Version})
 Suggests: libismrmrd-doc
-Description: ISMRM Raw Data format (ISMRMRD) - development files
+Description: development files for ISMRMRD
  The ISMRMRD format combines a mix of flexible data structures (XML header) 
  and fixed structures (equivalent to C-structs) to represent MRI data.
  .
@@ -54,9 +56,9 @@
 Package: libismrmrd-doc
 Architecture: all
 Section: doc
-Depends: libjs-jquery,
-         ${misc:Depends}
-Description: ISMRM Raw Data format (ISMRMRD) - documentation
+Depends: ${misc:Depends},
+         libjs-jquery
+Description: documentation for ISMRMRD
  The ISMRMRD format combines a mix of flexible data structures (XML header) 
  and fixed structures (equivalent to C-structs) to represent MRI data.
  .
@@ -70,11 +72,11 @@
 
 Package: ismrmrd-tools
 Architecture: any
-Depends: ismrmrd-schema,
-         libismrmrd1.2 (= ${binary:Version}),
-         ${misc:Depends},
-         ${shlibs:Depends}
-Description: ISMRM Raw Data format (ISMRMRD) - binaries
+Section: utils
+Depends: ${misc:Depends},
+         ${shlibs:Depends},
+         ismrmrd-schema
+Description: command-line tools for ISMRMRD
  The ISMRMRD format combines a mix of flexible data structures (XML header) 
  and fixed structures (equivalent to C-structs) to represent MRI data.
  .
@@ -84,12 +86,13 @@
  storing less well defined data structures, e.g. coil sensitivity maps or 
  other calibration data.
  .
- This package provides the binaries.
+ This package provides the command-line tools.
 
 Package: ismrmrd-schema
 Architecture: all
+Section: misc
 Depends: ${misc:Depends}
-Description: ISMRM Raw Data format (ISMRMRD) - XML schema
+Description: schema for ISMRMRD
  The ISMRMRD format combines a mix of flexible data structures (XML header) 
  and fixed structures (equivalent to C-structs) to represent MRI data.
  .

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# Hardening flags.
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
		-DUSE_SYSTEM_PUGIXML:BOOL=ON

override_dh_auto_build-indep:
	dh_auto_build -- apidoc

override_dh_auto_installdocs-indep:
	dh_installdocs --indep
	dh_doxygen --indep

override_dh_compress:
	dh_compress --exclude=examples

=== debian/tests/control ===
Tests: examples
Depends: build-essential,
         cmake,
         libismrmrd-dev,
         libismrmrd-doc
